#include "sort.h"

short int sort_przez_wstawianie(Tablica argum)
  { unsigned int i,j,zm_pom;
    if (argum.liczba_el<2) return 0; 
    for (i=2; i < argum.liczba_el+1; i++)
      { j=i-1;
        while (argum.wsk_na_tab[j] < argum.wsk_na_tab[j-1])
          { zm_pom = argum.wsk_na_tab[j];
            argum.wsk_na_tab[j] = argum.wsk_na_tab[j-1];
            argum.wsk_na_tab[j-1] = zm_pom;
            j--;
            if (j<1) break;
          }
      }
    return 1;
  }
  
short int sort_babelkowe(Tablica argum)
  { unsigned int i,j,zm_pom;
    if (argum.liczba_el<2) return 0; 
    for (j=1;j<argum.liczba_el; j++)
      for (i=argum.liczba_el-1; i>0; i--)
        if (argum.wsk_na_tab[i-1]>argum.wsk_na_tab[i])
          { zm_pom = argum.wsk_na_tab[i];
            argum.wsk_na_tab[i] = argum.wsk_na_tab[i-1];
            argum.wsk_na_tab[i-1] = zm_pom;
          }
    return 1;
  }
  
short int sort_qs(Tablica argum)
  { if (argum.liczba_el<2) return 0; 
    quicksort(argum.wsk_na_tab, 0, argum.liczba_el);
    return 1;
  }

short int sort_kopiec(Tablica argum)
{ if (argum.liczba_el<2) return 0; 
  int n = (int)argum.liczba_el, i = n>>1, j, w, t;
  while (1) {
	if (i>0) 
	t = argum.wsk_na_tab[--i];
  else {
	if (--n<=0) return;
	t = argum.wsk_na_tab[n]; 
	argum.wsk_na_tab[n] = argum.wsk_na_tab[0];
  }
  j = i;
  w = (i<<1)+1;
  while (w<n) {
	if (w+1<n && argum.wsk_na_tab[w+1]>argum.wsk_na_tab[w]) ++w;
	if (argum.wsk_na_tab[w]>t) { 
		argum.wsk_na_tab[j] = argum.wsk_na_tab[w];
		j = w; w = (j<<1)+1;
	}
	else break;
  }
  argum.wsk_na_tab[j] = t;
  }
return 1;
}
  
void zamien(unsigned int *a, unsigned int *b) 
	{ unsigned int t=*a; *a=*b; *b=t; }
	
void quicksort(unsigned int *tablica, unsigned int poczatek, unsigned int koniec) 
{
  if (koniec > poczatek + 1) 
  {
    unsigned int piv = tablica[poczatek], lewa = poczatek + 1, prawa = koniec;
    while (lewa < prawa) 
    {
      if (tablica[lewa] <= piv) 
        lewa++;
      else 
        zamien(&tablica[lewa], &tablica[--prawa]);
    }
    zamien(&tablica[--lewa], &tablica[poczatek]);
    quicksort(tablica, poczatek, lewa);
    quicksort(tablica, prawa, koniec);
  }
}
