#include "tab.h"

short int alokuj (Tablica *wsk, unsigned int rozmiar)
  { if (!rozmiar) return 0;
    wsk->wsk_na_tab = (unsigned int*) malloc(rozmiar*sizeof(unsigned int));
    if (!wsk->wsk_na_tab) return 0;
    wsk->liczba_el = rozmiar;
    return 1;  
  }
  
short int zwolnij (Tablica *wsk)
	{ if (!wsk->wsk_na_tab) return 0;
	free(wsk->wsk_na_tab);
	wsk->liczba_el = 0;
	return 1;
	}

void wypelnij (Tablica tabarg)
	{ unsigned int i;
	  for (i=0; i<tabarg.liczba_el; i++)
	  	tabarg.wsk_na_tab[i] = rand();
	}

void wypisz (Tablica tabarg)
	{ unsigned int i;
	printf("\n");
	for (i=0; i<tabarg.liczba_el; i++)
		printf("E%u=%u ", i, tabarg.wsk_na_tab[i]);
	printf("\n");
	}

void kopiuj (Tablica zrodlo, Tablica cel)
	{ memcpy(cel.wsk_na_tab, zrodlo.wsk_na_tab, zrodlo.liczba_el*sizeof(unsigned int));
	}